/*
 * Copyright (c) 2014 LAAS/CNRS
 * Copyright (c) 2008-2014 Max Planck Institute for Biological Cybernetics
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 */
#include "acheader.h"

#include "main.h"
#include "data_struct.h"

#define AD_YAW		0
#define AD_ROLL		1
#define AD_PITCH	2
#define AD_PRESS	3
#define AD_UBAT		4
#define AD_ACC_Z	5
static uint8_t AD_ACC_Y	= 7;
static uint8_t AD_ACC_X	= 6;

#define ANALOG_OFF ADCSRA=0
#define ANALOG_ON ADCSRA=(1<<ADEN)|(1<<ADSC)|(0<<ADATE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE)

// nasty part atmo
#define DESIRED_H_ADC 800

//#######################################################################################
// Initialize analog-digital converter
void ADC_Init(void)
//#######################################################################################
{
  if (fc_version < 25) {
    AD_ACC_Y = 6;
    AD_ACC_X = 7;
  } else {
    AD_ACC_Y = 7;
    AD_ACC_X = 6;
  }

  ADMUX = 0;//External reference
  ANALOG_ON;
}

//TODO rewrite this function in english
void calibrateAtmoPress(void)
{
	unsigned int off;
	off = 90; //	eeprom_read_byte(&EEPromArray[EEPROM_ADR_LAST_OFFSET]);
	if(off > 20) off -= 10;
	OCR0A = off;
//	Delay_ms_Mess(100);

	CountCalibAtmoPress1kHz = 0;
	while(CountCalibAtmoPress1kHz < 100){};

	if(mikKopData.rawAtmoPress < DESIRED_H_ADC) off = 0;

	for(; off < 250;off++)
	{
		OCR0A = off;

		CountCalibAtmoPress1kHz = 0;
		while(CountCalibAtmoPress1kHz < 50){};

		if(mikKopData.rawAtmoPress < DESIRED_H_ADC) break;
	}
	//eeprom_write_byte(&EEPromArray[EEPROM_ADR_LAST_OFFSET], off);
	//DruckOffsetSetting = off;
	//Delay_ms_Mess(300);

		CountCalibAtmoPress1kHz = 0;
		while(CountCalibAtmoPress1kHz < 50){};

}


//#######################################################################################
// ISR for analog-digital converter
SIGNAL(ADC_vect)
//#######################################################################################
{
	static unsigned char channel=0,state = 0;
	switch(state++)
	{
	case 0:
		mikKopData.rawGyroY = ADC;
		channel = AD_ROLL;
		break;
	case 1:
		mikKopData.rawGyroX = ADC;
		channel = AD_YAW;
		break;
	case 2:
		mikKopData.rawGyroZ = ADC;
		channel = AD_ACC_Y;
		break;
	case 3:
		mikKopData.rawAccY = ADC;
		channel = AD_ACC_X;
		break;
	case 4:
		mikKopData.rawAccX = ADC ;
		channel = AD_UBAT;
		break;
	case 5:
		mikKopData.battVoltage = (signed int) ((3 * mikKopData.battVoltage + ADC / 3) / 4);
		channel = AD_ACC_Z;
		break;
	case 6:
		mikKopData.rawAccZ = ADC;
		channel = AD_PRESS;
		break;
	case 7:
		mikKopData.rawAtmoPress = ADC;
		channel = AD_PITCH;
		//AdReady = 1;
		break;
	default:
		channel = 0; state = 0; channel = AD_PITCH;
		break;
	}
	ADMUX = channel;
	ANALOG_ON;
	if(state != 0) ANALOG_ON;
}
