/*
 * Copyright (c) 2014-2015 LAAS/CNRS
 * Copyright (c) 2008-2014 Max Planck Institute for Biological Cybernetics
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 */
#ifndef _MAIN_H
#define _MAIN_H

#define RED_LED_OFF	PORTB &=~0x01
#define RED_LED_ON	PORTB |= 0x01

#define GRN_LED_ON	((fc_version<25)? (PORTB&=~0x02) : (PORTB|=0x02))
#define GRN_LED_OFF	((fc_version<25)? (PORTB|=0x02) : (PORTB&=~0x02))

#define SYSCLK F_CPU
#define EEPROM_ADR_NO_ONE			10
#define EEPROM_ADR_QC	            1

#define EEPROM_ADR_ACC_ROLL         2
#define EEPROM_ADR_ACC_PITCH        6
#define EEPROM_ADR_ACC_YAW          10

#define QUAC 						42

#define FCFLAG_MOTOR_RUN  	0x01 //ToDo maybe not needed - do check
#define FCFLAG_FLY        	0x02
extern char MotorsOn;
extern volatile unsigned char FCFlags;

#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/eeprom.h>
#include <avr/boot.h>
#include <avr/wdt.h>

#include "timer0.h"
#include "uart.h"
#include "twi.h"
#include "ad_converter.h"

/* board version */
extern unsigned char fc_version;

//void UpdateStatistics(void);

extern int UBRR;

extern volatile unsigned int receivedCmds, ctrlSteps, sendPackets, sendPackets1, stateEstSteps;

//#define DELAY_US(x)	((unsigned int)( (x) * 1e-6 * F_CPU ))


#define AVE_BUFFER_SIZE 1


/* --- settings ------------------------------------------------------------ */

void	tk3_load_settings(void);

#endif //_MAIN_H
