/*
 * Copyright (c) 2014-2015 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 *					Anthony Mallet on Tue Jun  3 2014
 */
#include "acheader.h"

#include <avr/eeprom.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "tk3-mikrokopter.h"
#include "data_struct.h"
#include "main.h"

#define TK3SET_ROBOT		"robot-id"

/* default settings, stored in the MCU EEPROM. The format is a list
 * of nul-terminated strings, interpreted as a key/value/descr */
static const char tk3_dparams[] EEMEM __attribute__((used)) = {
  TK3SET_MAGIC "\0"
  TK3SET_ROBOT "\0"	"\0\0\0\0"	"robot number" "\0"
};

/* --- load_settings ------------------------------------------------------- */

void
tk3_load_settings(void)
{
  int32_t value;
  char key[16];

  if (tk3_settings_init()) abort();

  while(!tk3_settings_next(key, sizeof(key), &value)) {
    if (!strcmp_P(key, PSTR(TK3SET_ROBOT))) {
      mikKopData.robotId = value;
    }
  }
}
