/*
 * Copyright (c) 2014 LAAS/CNRS
 * Copyright (c) 2008-2014 Max Planck Institute for Biological Cybernetics
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 */
#ifndef TK3_FLCTRL_TIMER0_H
#define TK3_FLCTRL_TIMER0_H

#define TIMER_Div        CK8
#define TIMER_RELOAD_VALUE  250
#define HEF4017R_ON     PORTC |=  (1<<PORTC6)
#define HEF4017R_OFF    PORTC &= ~(1<<PORTC6)

void Timer_Init(void);

/*
void time(void);
void Delay_ms(unsigned int);
void Delay_ms_Mess(unsigned int);
unsigned int SetDelay (unsigned int t);
char CheckDelay (unsigned int t);
*/

extern volatile unsigned int CountMillisecondsLastTx0, CountMillisecondsLastTx1, CountMillisecondsLastRx0;
extern volatile unsigned int CountMillisecondsLastCtrlStep, CountMillisecondsInEmergency,CountCalibAtmoPress1kHz;
extern volatile unsigned int CountClockOverflow; // incremented every 0.097 milliseconds
//extern volatile unsigned char updateMotor, updateImu, processData0, sendData0;

extern volatile unsigned int flightCtrlPerMsDecs, estPerMsDecs, extCmdProcessPerMsDecs, sendDataPerMsDecs, imuTransPerMsDecs;

extern volatile unsigned char mirrorTimer;

#endif /* TK3_FLCTRL_TIMER0_H */
