/*
 * Copyright (c) 2014 LAAS/CNRS
 * Copyright (c) 2008-2014 Max Planck Institute for Biological Cybernetics
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 */
#ifndef _UART_H
#define _UART_H

#include <stdio.h>

#define MIK_KOP_DATA_PACKET_SIZE 10

extern unsigned volatile char TransmissionComplete;

int	uart_putchar(char c, FILE *stream);

void UART_Init(void);
void IMUTransmission(void);
void DataReception(void);

void sendTxData0(void);
void processRxData(void);

//TODO: write comment here
struct str_CommandsPacket
{
	unsigned char cmd0;
	unsigned char cmd1;
	unsigned char cmd2;
	unsigned char cmd3;
};

extern struct str_CommandsPacket cmdBuf;

//TODO: write comment here
struct str_SingleValue
{
	signed int id;
	signed int value;
};

//TODO: write comment here
struct str_CommandsPlusValuePacket
{
	signed char pitch;
	signed char roll;
	signed char yawrate;
	unsigned char thrust;
	signed int id;
	signed int value;
};

extern struct str_CommandsPlusValuePacket commandsPlusValue;

//TODO: write comment here
struct str_CommandsPlusIdPacket
{
	signed char pitch;
	signed char roll;
	signed char yawrate;
	unsigned char thrust;
	signed int id;
};

extern struct str_CommandsPlusIdPacket commandsPlusId;

//TODO: write comment here
struct str_CommandsPlusDataIdsPacket
{
	signed char pitch;
	signed char roll;
	signed char yawrate;
	unsigned char thrust;
	unsigned char activeDataIds[MIK_KOP_DATA_PACKET_SIZE];
};

extern struct str_CommandsPlusDataIdsPacket commandsPlusDataIds;

//ids of the data currently to be sent
extern unsigned char activeDataIds[MIK_KOP_DATA_PACKET_SIZE];


#endif //_UART_H
